package com.example.android_sensor_plot;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.TimeSeries;
import org.achartengine.model.XYMultipleSeriesDataset;
import org.achartengine.renderer.XYMultipleSeriesRenderer;
import org.achartengine.renderer.XYSeriesRenderer;

import android.content.Context;
import android.graphics.Color;
import android.os.Environment;

public class Plotter {
	
	TimeSeries series1;
	TimeSeries series2;
	TimeSeries series3;
	float t=0f;
	XYMultipleSeriesRenderer mRenderer;
	
public void AddPoint(float[] value)  // Add new point to series
{
	t=t+1f;
		series1.add(t, value[0]);
		if(value[1] < 10000f)series2.add(t, value[1]); // filter blank data
		if(value[2] < 10000f)series3.add(t, value[2]); // finter blank data
	mRenderer.setXAxisMin(t-50);                       // set window width
if(series1.getItemCount()>500)series1.clear();        // auto clear series
}


public GraphicalView getView(Context context)
{
		
		series1=new TimeSeries("X");
		series2=new TimeSeries("Y");
		series3=new TimeSeries("Z");

XYMultipleSeriesDataset dataset=new XYMultipleSeriesDataset();  
dataset.addSeries(series1);
dataset.addSeries(series2);
dataset.addSeries(series3);

mRenderer =new XYMultipleSeriesRenderer();  //chart properties
mRenderer.setApplyBackgroundColor(true);
mRenderer.setBackgroundColor(Color.BLACK);
mRenderer.setShowGrid(true);

XYSeriesRenderer renderer=new XYSeriesRenderer(); // series properties X
renderer.setColor(Color.RED);
renderer.setLineWidth(5f);
mRenderer.addSeriesRenderer(renderer);

XYSeriesRenderer renderer1=new XYSeriesRenderer(); // series properties Y
renderer1.setColor(Color.GREEN);
renderer1.setLineWidth(5f);
mRenderer.addSeriesRenderer(renderer1);

XYSeriesRenderer renderer2=new XYSeriesRenderer(); // series properties Z
renderer2.setColor(Color.BLUE);
renderer2.setLineWidth(5f);
mRenderer.addSeriesRenderer(renderer2);

GraphicalView gview=ChartFactory.getLineChartView(context, dataset, mRenderer);
		return gview;		
}

public void clear()
{
	series1.clear();
	series2.clear();
	series3.clear();
	t=0f;
}

public void WriteCSV() 
{ 

File root = new File(Environment.getExternalStorageDirectory(), "SensorData");
if (!root.exists()) 
{
    root.mkdirs();
}

File csvfile = new File(root, "data.csv");
FileWriter writer;
try {
	writer = new FileWriter(csvfile);
	for(int i=0;i<series1.getItemCount();i++)
	{   
		writer.append(String.format("%d,%f,%f,%f\n", i,series1.getY(i),series2.getY(i),series3.getY(i)));
	}

	writer.flush();
	writer.close();

} catch (IOException e) {
	// TODO Auto-generated catch block
	e.printStackTrace();
}

}

}
