package com.example.android_sensor_plot;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.achartengine.GraphicalView;

import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Spinner;

public class SensorPlot extends Activity implements SensorEventListener {
@Override
	protected void onPause() {
		super.onPause();
		mSensorManager.unregisterListener(this);
	}

	@Override
	protected void onResume() {
		super.onResume();
		 mSensorManager.registerListener(this, cSensor, SensorManager.SENSOR_DELAY_NORMAL);
	}

Spinner spinner1;
SensorManager mSensorManager;
Sensor cSensor;
List<Sensor> msensorList;
int cType=0;
Plotter plotter;
LinearLayout layout1;
GraphicalView plotter_view;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sensor_plot);
		spinner1=(Spinner) findViewById(R.id.spinner1);
		layout1=(LinearLayout) findViewById(R.id.LinearLayout1);
		Button button1=(Button) findViewById(R.id.button1);
		Button button2=(Button) findViewById(R.id.button2);
		Button button3=(Button) findViewById(R.id.button3);
		
		 mSensorManager= (SensorManager) getSystemService(SENSOR_SERVICE);
		 msensorList = mSensorManager.getSensorList(Sensor.TYPE_ALL);  // list all sensors
		 cSensor = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);  // init default sensor
		 List<String> list = new ArrayList<String>();
		 Sensor tmp;
		    for (int i=0;i<msensorList.size();i++){ // copy sensor list to string list
		     tmp = msensorList.get(i);
		    list.add(tmp.getName());
		       
		    }	
		    // init dropdown list
			ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
					android.R.layout.simple_spinner_item, list);
				dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		 spinner1.setAdapter(dataAdapter);
		 spinner1.setOnItemSelectedListener(new CustomOnItemSelectedListener());
		  // **************************
		 
		 plotter=new Plotter(); // construct plotter class
		  plotter_view=plotter.getView(layout1.getContext()); 
		 layout1.addView(plotter_view); // put chart to layout
		 
		button1.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
			plotter.clear();	
			}
		});
		button2.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
finish();				
			}
		});
		
		button3.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				plotter.WriteCSV();	
			}
		});
	}

	
	
	public class CustomOnItemSelectedListener implements OnItemSelectedListener {

		@Override
		public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2,
				long arg3) {

Sensor tmp=msensorList.get(arg2); //get current sensor
cType=tmp.getType();             // get current sensor type

mSensorManager.unregisterListener(SensorPlot.this); // remove all sensor
cSensor = mSensorManager.getDefaultSensor(cType);    // set selected sensor as default sensor
mSensorManager.registerListener(SensorPlot.this, cSensor, SensorManager.SENSOR_DELAY_NORMAL); // start listen to sensor
plotter.clear(); // clear chart

		}

		@Override
		public void onNothingSelected(AdapterView<?> arg0) {
			
		}
		
	}


	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		
	}

	@Override
	public void onSensorChanged(SensorEvent event) {
		if(event.sensor.getType()==cType)
		{
		plotter.AddPoint(event.values); // add new point to chart
		plotter_view.invalidate();      // refresh graphical view
		}
	}

}
